#include <bits/stdc++.h>

using namespace std;

int main()
{   ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n,m;
    cin>>n>>m;
    vector<long long>a(n),b(n),c(m),d(m);
    for(int i=0;i<n;i++)
        cin>>a[i]>>b[i];
    for(int i=0;i<m;i++)
        cin>>c[i]>>d[i];
    bool jednakiab=true;
    for(int i=0;i<n;i++)
        if(a[i]!=b[i])
            jednakiab=false;
    bool jednakicd=true;
    for(int i=0;i<m;i++)
        if(c[i]!=d[i])
            jednakicd=false;
    long long sum=0;
    if(n==1)
    {
        for(int i=0;i<m;i++)
            sum+=d[i];
        long long res=min(sum,b[0]);
        cout << res << endl;
        cout << m << endl;
        for(int i=0;i<m;i++)
        {
            long long vr=0;
            if(sum-res>0)
            {
                vr=min(d[i]-c[i],sum-res);
                sum-=vr;
            }
            cout << 1 << " " << i+1 << " " << d[i]-vr << endl;
        }
        return 0;
    }

    return 0;
}